#if !defined(ARMADILLO_FRED)
#define ARMADILLO_FRED

/*
aout 2014
Quelques fonctions qui combinent les classes de Armadillo (algebre linaire)
et root (dessin etc)

 */


#include <math.h>
#include <armadillo>



#include <iostream>
#include <fstream>
#include <stdlib.h>

#include <vector>


using namespace arma;
using namespace std;


#include <TH1.h>

#include <TCanvas.h>  // pour graphisme

#include "config_fred.h"

//=======================
void Ecrit_fichier(cx_vec & V, ofstream & fich);
void Ecrit_fichier(cx_vec &V,const char * nom_fich);

void Lit_fichier(cx_vec &V,ifstream & fich);

void Lit_fichier(cx_vec &V,const char * nom_fich);

//========================


//=======================================
int Recherche_indice_du_max(vec &V);

/*===================================
 Permutte circulaire de (d) elements
  */
vec Permut_circ2(vec &V,int d);
//============================
/*
Entrée:
 matrice complexe ou reelle M
Sortie:
 val_p, vect _p  ordonnées par module croissant
 */

void Diago(cx_vec & val_p,cx_mat vect_p, cx_mat & M);

void Diago(cx_vec & val_p,cx_mat vect_p, mat & M);

//================================
/*
Dessin du vecteur en histogramme
 */

TH1D*  Dessin(vec &V,const char * titre="Vecteur",int superp=0,const char *opt="histo",int opt_log=0);

TH1D*  Dessin(vec &V,const char * titre,const char *opt);
TH1D*  Dessin(Col<int> &V,const char * titre,const char *opt=0);

TH1D*  Dessin(vec &V,const char * xtitre,const char * ytitre,double xmin,double xmax,const char * titre, int superp=0,const char *opt="histo",double ymin=-1111, double ymax=-1111,int col=1,int opt_log=0);

TH1D *  Dessin(vec & V,TCanvas * c);

//========= dessin ========================
//  c : fenetre ou dessiner
// superp: =0 si premier figure, 1,2.. si superposition (style de ligne)
// ymin, ymax pour fixer. (-1111 si libre)
TH1D*  Dessin(vec& V,const char * xtitre,const char * ytitre,double xmin,double xmax,const char * titre,TCanvas * c,int superp,const char* opt="histo",double ymin=-1111, double ymax=-1111,int col=1,int opt_log=0);


//========= dessin 2D (x[i],y[i])========================
TCanvas *  Dessin(vec &x,vec &y,const char * xtitre="x",const char * ytitre="y",const char * titre="Vecteur");


//========= dessin 3D (x[i], y[i], z[i])========================
TCanvas *  Dessin(vec &x,vec &y,vec &z, const char * xtitre="x",const char * ytitre="y",const char * ztitre="z",const char * titre="Vecteur");


//========= dessin sur cercle========================
void  Dessin_phases(vec &V,const char * titre);

//========= dessin  sur colonne a l abcisse x========================
//  style du Marker: 6: point  8: petit cercle
void  Dessin_col(vec &V,double xx, TCanvas *c,int col=2, int style=6);


// dessin des points dans le plan complexe
TCanvas *  Dessin(cx_vec &V,const char * titre);

// Dessine les histogrammes des phases et des modules des elements du vecteur
void Dessin_histo_phases_modules(cx_vec &V,double module_min, double module_max);




//==========Matrices =========



TCanvas *  Dessin(mat &M,const char * titre="Matrice", const char * option="colz");
TCanvas *  Dessin(mat &M,const char * xtitre,double xmin,double xmax,const char * ytitre,double ymin,double ymax,const char * titre,const char * option="colz",double zmin=-1111, double zmax=-1111);
//  c : fenetre ou dessiner  
// superp: =0 si premier figure, 1,2.. si superposition
// zmin, zmax pour fixer. (-1111 si libre)
 TCanvas*  Dessin(mat &M,const char * xtitre,double xmin,double xmax,const char * ytitre,double ymin,double ymax,const char * titre,const char * option,TCanvas * c,int superp,double zmin=-1111, double zmax=-1111);

//--------------------------
/*
Dessine les lignes de niveau de || (z-P)^-1 ||_2  dans le plan complexe z.
 */
void Dessin_Pseudo_Spectre(mat & M,double xmin=-1,double xmax=1,double ymin=-1,double ymax=1);





//=====================================

// OPERATIONS SUR LES VECTOR

//====================
//void Clear(vector & V);


ostream & operator <<(ostream & sortie,  const vector<pair<int,int>> & V);
ostream & operator <<(ostream & sortie,  const vector<pair<double,double>> & V);

//==========================
// Affiche vector




//==========================
// Affiche vector

template <typename T>
ostream & operator <<(ostream & sortie,  const vector<T> & V);

ostream & operator <<(ostream & sortie,  const vector<int> & V);

ostream & operator <<(ostream & sortie,  const vector<double> & V);
ostream & operator <<(ostream & sortie,  const vector<Complex> & V);

ostream & operator <<(ostream & sortie,  const vector<vector<int> > & L);

ostream & operator <<(ostream & sortie,  const vector<string> & V);

ostream & operator <<(ostream & sortie,  const vector<vector<string> > & L);


ostream & operator <<(ostream & sortie,  const vector<unsigned char> & V);


//=============================================
bool Subset(vector<int> V1,vector<int> V2);
/*
sortie:
   1 si V1 est un sous ensemble de V2
   0 sinon.

Exemple:
   vector<int> V1; V1.push_back(2); V1.push_back(1);  V1.push_back(3);
   vector<int> V2; V2.push_back(1); V2.push_back(1);  V2.push_back(3);
   vector<int> V3; V3.push_back(3); V3.push_back(1); 

   cout<<V1<<endl;    cout<<V2<<endl;    cout<<V3<<endl;

   cout<<"V1 in V2 :"<<Subset(V1,V2)<<endl;
   cout<<"V3 in V1 :"<<Subset(V3,V1)<<endl;
   cout<<"V3 in V2 :"<<Subset(V3,V2)<<endl;


 */


//===========================
vector<int> Sym_diff(vector<int> A,vector<int> B);
/*
Renvoit elements presents dans un seul vecteur (avec multiplicité)

Exemple

vector<int> V1; V1.push_back(2); V1.push_back(1);  V1.push_back(3);
vector<int> V2; V2.push_back(1); V2.push_back(1);  V2.push_back(4);
cout<<V1<<endl;
cout<<V2<<endl; 
cout<<Sym_diff(V1,V2)<<endl;

renvoit
[2,1,3]
[1,1,4]
[1,2,3,4]
 */

//===========================
vector<int> diff(vector<int> A,vector<int> B);
/*
Renvoit elements presents A et pas dans B

Exemple

vector<int> V1; V1.push_back(2); V1.push_back(1);  V1.push_back(1);  V1.push_back(3);
vector<int> V2; V2.push_back(1);   V2.push_back(4);
cout<<V1<<endl;
cout<<V2<<endl; 
cout<<diff(V1,V2)<<endl;

renvoit
[2,1,1,3]
[1,4]
[1,2,3]
 */

//===========================
vector<int> Intersection(vector<int> A,vector<int> B);
/*
Renvoit elements presents dans les deux vecteurs (avec multiplicité)

Exemple

vector<int> V1; V1.push_back(2); V1.push_back(1);  V1.push_back(3);
vector<int> V2; V2.push_back(1); V2.push_back(1);  V2.push_back(4);
cout<<V1<<endl;
cout<<V2<<endl; 
cout<<Intersection(V1,V2)<<endl;

renvoit
[2,1,3]
[1,1,4]
[1]
 */
//===========================
vector<int> Union(vector<int> A,vector<int> B);
/*
Renvoit union des elements des  deux vecteurs

Exemple

vector<int> V1; V1.push_back(2); V1.push_back(1);  V1.push_back(3);
vector<int> V2; V2.push_back(1); V2.push_back(1);  V2.push_back(4);
cout<<V1<<endl;
cout<<V2<<endl; 
cout<<Union(V1,V2)<<endl;

renvoit
[2,1,3]
[1,1,4]
[1,1,2,3,4]
 */
//===========================
// renvoit true si j est pas contenu dans V, false si contenu
int Not_find_j_in_V(int j,vector<int> V);



//Conversions
vec vector_to_vec(vector<double> &v);
cx_vec vector_to_vec(vector<Complex> &v);


#endif
