#include "geom/aritm.h"
#include "fichiers/fichiers.h"

#include <math.h>

#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <time.h>

#include <stdio.h>

#include <stdio.h>




//==== pour attendre: entre 1 ==========
void Suite()
{
    int a;
    cout<<" entrer un chiffre pour continuer..?"<<flush;
    cin>>a;
    return;
}
//========== exp(complex) avec precision 1e-14============
Complex exp_p(Complex z)
{
    double a=real(z);
    double b=imag(z);
    if (abs(b)>1e13) cerr<<"phase trop grande, ereur de precision dans aritm.cc"<<endl;
    else b=modulo(b,2*Pi_);
    return exp(a)*(cos(b)+I_*sin(b));
}
/*################################################
  routine aritmetique:
  (double) modulo(double x, double y)
	x=y*b+reste ;   b entier dans Z,   0<= reste <y
	renvoit reste.
      Rem : idem fmod(x,y) sauf que fmod renvoie des negatifs si x<0 */
double  modulo(double x,double y)
{
    double res;

    res=x-y*floor(x/y);
    return  res;
}

//===========================
// renvoit la valeur de X +b* y, la plus proche de x (b entier variable)
double Ajuste(double X,double x,double y)
{
    return Ajuste1((x-X)/y)*y+X;
}

//===========================
// renvoit l'entier le plus proche
int Ajuste1(double x)
{
    return floor(x+0.5);
}

//========== carre============
double sqr(double x)
{
    return x*x;
}
//========== signe ============
// renvoit 1,-1 selon le signe de x
int sign(double x)
{
    if (x>=0) return 1;
    return -1;
//else  return 0;
}

//=== Kronecker ==================
//renvoit 1 si i=j  sinon renvoit 0
int Delta(int i,int j)
{

    if (i==j)
        return 1;
    else return 0;
}

//=======================================

int iquotient(int x,int y)
{
    int q=x/y;
    if (x<0) q=((x+1)/y)-1;
    return q;
}
//--------------------------------------------

int ireste(int x,int y)
{
    return (x-y*iquotient(x,y));
}

//===================
/*Liste des diviseurs de n
dans l'ordre croissant
 */
vector<int> liste_diviseurs(int n)
{
	vector<int> l;
	for(int j=1;j<=n;j++)
	{
		if(ireste(n,j)==0)
			l.push_back(j);
	}

	return l;
}
//======================================
/*
exemple:
for (auto i: sort_indexes(v)) 
{
  cout << v[i] << endl;
}
 */
template <typename T>
vector<size_t> sort_indexes(const vector<T> &v) 
{

  // initialize original index locations
  vector<size_t> idx(v.size());
  for (size_t i = 0; i != idx.size(); ++i) idx[i] = i;

  // sort indexes based on comparing values in v
  sort(idx.begin(), idx.end(),
       [&v](size_t i1, size_t i2) {return v[i1] < v[i2];});

  return idx;
}

//=======================
//---- on decompose i en base N.
// entr: i,N,i2
// sortie Vecteur mot
//              = i crit en base N,  et seulement mot[0->i2-1]
// Exemple: 6 en base 2 = 110 -> Vecteur: (0,1,1)
/*
Vecteur Decomposition_base(int i,int N,int i2)
{
    
        Vecteur mot(0,i2-1); // mot en base N
        
        int ic=i;
 
        for(int j=1; j<=i2; j++)
        {
            int i1=ic%N;
            mot[j-1]=i1+1;
            ic=(ic-i1)/N;
        }
 return mot;

}
*/         
           

//===================
//  (-1)^n
int parite(int n)
{
    if ((n%2)==0)
        return 1;
    else return -1;
}
         

//===================
//  (I)^n
Complex parite_I(int n)
{
    if ((n%4)==0)
        return 1;
    else if ((n%4)==1)
      return I_;
    else if ((n%4)==2)
      return -1;
    else if ((n%4)==3)
      return -I_;
}

//----- a^b , avec b>0----
int ipow(int a,int b)
{
    if (b<0)
    {
        cerr<<"Erreure b<0 dans aritm.cc"<<endl;
        abort();
    }

    int res=1;
    for (int i=1;i<=b;i++)
        res*=a;

    return res;
}

//====== partie entiere sans la frontiere: [x]m= 0 si x dans ]0,1] etc...
double floor_m(double x)
{
    return (-1-floor(-x));
}


/*################################################*/
void Initialiser_le_hasard()
{
    // initialisation du generateur aleatoire
    time_t t;
    srand( (unsigned) time (&t));
}


//======================================
/*
log(fact(x))=log(Gamma(x+1))
*/

#include <gsl/gsl_sf_gamma.h>

double log_fact(double x)
{
    return  gsl_sf_lngamma(x+1);

}




/*====================================================
Factorielle d'un entier
*/
double fact(long n)
{

    if (n<0)
    {
        cerr<<"erreur : factorielle de n<0 !="<<n<<endl;
        return 1;
    }
    if (n==0) return (long)1;
    double res(1);
    for (long k=1; k<=n;k++)
    {
        res*=k;
    }
    return res;
}
//___________________________
double fact(int n)
{

    if (n<0)
    {
        cerr<<"erreur : factorielle de n<0 !="<<n<<endl;
        return 1;
    }
    if (n==0) return 1;
    double res(1);
    for (int k=1; k<=n;k++)
    {
        res*=k;
    }
    return res;
}
//-------------------------
long double fact2(int n)
{

    if (n<0)
    {
        cerr<<"erreur : factorielle de n<0 !="<<n<<endl;
        return 1;
    }
    if (n==0) return 1;
    long double res(1);
    for (int k=1; k<=n;k++)
    {
        res*=k;
    }
    return res;
}

/* ========================
rapport de deux factorielle:
   (n!)/(n-i)! = n!/p! avec i=n-p
*/
double rfact(int n,int i)
{

    if ((n<0)||(n<i))
    {
        cerr<<"erreur dans rfact(): n="<<n<<" i="<<i<<endl;
        return 1;
    }
    if (n==0) return 1;
    double res(1);
    for (int k=n-i+1; k<=n;k++)
    {
        res*=k;
    }
    return res;
}
//------------------------
long double rfact2(int n,int i)
{

    if ((n<0)||(n<i))
    {
        cerr<<"erreur dans rfact(): n="<<n<<" i="<<i<<endl;
        return 1;
    }
    if (n==0) return 1;
    long double res(1);
    for (int k=n-i+1; k<=n;k++)
    {
        res*=k;
    }
    return res;
}

/* ========================
rapport de deux factorielle:
   (n-i!)/(i)! avec 0<=i<=n
*/
double Rfact(int n,int i)
{

    if ((n<0)||(n<i)||(i<0))
    {
        cerr<<"erreur dans Rfact(): n"<<n<<" i="<<i<<endl;
        return 1;
    }
    if (n==0) return 1;
    if ((n-i)>i)
        return rfact(n-i,n-2*i);
    else
        return 1/rfact(i,2*i-n);
}

/*====================================================
Factorielle double d'un entier  n!!
*/
double dfact(long n)
{

    if (n<0)
    {
        cerr<<"erreur : factorielle de n<0 !="<<n<<endl;
        return 1;
    }
    if (n==0) return (long)1;
    double res(1);
    for (long k=0; k<n;k=k+2)
    {
        res*=(n-k);
    }
    return res;
}
// -------------
double dfact(int n)
{

    if (n<0)
    {
        cerr<<"erreur : factorielle de n<0 !="<<n<<endl;
        return 1;
    }
    if (n==0) return (int)1;
    double res(1);
    for (int k=0; k<n;k=k+2)
    {
        res*=(n-k);
    }
    return res;
}

/*====================================================
  coef du binome C(n,p)
permet d'utilier n trs grand.
*/
double binome(long n,long p)
{
    //  cout<<"C="<<(fact(n)/fact(n-p)/fact(p))<<endl;

    if ((n<0)||(p<0)||(p>n)) return 1;

    if ((p>(n/2)+1))
        return binome(n,n-p);


    double res=1;
    for (int k=1;k<=p;k++)
        res*= (n-p+k)/(1.0*k);

    //  cout<<" Cres="<<res<<endl;

    return res;

}
//==========================================
Complex binome(Complex z,long p)
{
    //  cout<<"C="<<(fact(n)/fact(n-p)/fact(p))<<endl;

    if (p<=0) return 1;

Complex res=1;

    for(long k=0;k<p;k++)
    res=res*((z-(double)k)/(double)(p-k));        
    
    
    return res;

}
//================ Fonction Zeta de Rimeann avec Giac et Pari.

Complex Zeta(Complex z)
{
  /*
giac::gen c(z.real(),z.imag()); 
//cout<<"c="<<c<<endl;
giac::gen z2=giac::pari_zeta(c);
//cout<<"z2="<<z2<<endl;
Complex z3=0;
if (z2.type==giac::_DOUBLE_)
     z3=z2._DOUBLE_val;
else
    z3=Complex(z2._CPLXptr->_DOUBLE_val,(z2._CPLXptr+1)->_DOUBLE_val);
//cout<<"z3="<<z3<<endl; 
return z3;
  */
  return 0;
}

/*===========================================
 Fonction Polynome d'Hermite   Hn(X)
 */
double Hermite(double X,int n)
{
    if (n==0) return 1;

    double H1v,H0(1);
    double H1=2*X;

    for (int k=2;k<=n;k++) // calcul de Hk
    {
        H1v=H1;
        H1=2*X*H1-2*(k-1)*H0;
        H0=H1v;
    }

    return H1;
}
/*===========================================
 Polynomes d'Hermite   Hn(X) pour n=0->N
 */
/*
Vecteur Hermite_tab(double X,int N)
{
    if (N<0) cout<<"Il faut N>=0"<<endl;

    Vecteur H(0,N);
    H[0]=1;
    if (N>=1)
        H[1]=2*X;

    for (int n=2;n<=N;n++) // calcul de Hk
        H[n]=2*X*H[n-1]-2*(n-1)*H[n-2];


    return H;
}
*/



/*=======================================================
Recherche le min de la fonction f(x,y)
par la methode du gradient

entree : xy : point de depart
          fmin : seuil
sortie : xy : minimum
         avec f(x,y)<=fmin
*/
void Recherche_min(double & x,double & y,double (*fonct)(double,double),double fmin)
{
    double f;
    double delta,pas(0.01);
    int compteur(0);

    do
    {
        compteur++;

        delta=pas/100;

        //--calcul du gradient -----

        f=fonct(x,y);
        double gx=(fonct(x+delta,y)-f)/delta;
        double gy=(fonct(x,y+delta)-f)/delta;
        double g=sqrt(gx*gx+gy*gy);

        //----- nouveau point ------

        double x2,y2;
        do
        {
            pas/=2;
            x2=x-pas*gx/g;
            y2=y-pas*gy/g;
            //cout<<"pas="<<pas<<endl;
        }
        while (fonct(x2,y2)>=f && (pas>1e-3));
        pas*=2;

        x=x2;
        y=y2;
        //cout<<"x="<<x<<"y="<<y<<" f="<<f<<endl;
        // point2(x,y);

    }  // do
    while (f>fmin && (compteur<=500));

    if (compteur>=500)
    {
        cout<<"je bloque...f="<<f<<"  pas="<<pas<<endl;
        //color(GREEN);// circle(x,y,0.01);
        //color(RED);
    }
    else   //color(YELLOW); //circle(x,y,0.01);
    {
        //color(RED);
    }

}

/* ==============================================================
  Suit un objet qui se deplace dans le plan x(t) y(t),
   pour t=0 a t=1.
  A l'aide de l'indicateur:
      F(x,y,t)=1   si on est pres de l'objet
            =0   si on est loin.

  entree : x,y  pour t=0  t.q. F(x,y,0)=1
           F(x,y,t) : fonction
           dt : pas initial

  sortie : x,y  pour t=1   t.q. F(x,y,1)=1
*/
void Suivit(int (*F)(double,double,double), double & x,double & y, double dt,double dx, double dy)
{
    double t(0),xp(0),yp(0);
    int S;

    do
    {
        t+=dt;  // incrementation
        if (t>1) t=1;

        S=F(x,y,t);

        cout<<" pour t="<<t<<" x="<<x<<" y="<<y<<"  S="<<S<<endl;

//        if (S==0)

        if (S==1)
            dt*=1.1;  // acceleration
        else
        {
            cout<<" je bouge.."<<endl;
            if (S==0)
            {
                xp=x+dx;
                yp=y;
                S=F(xp,yp,t);
            }



            if (S==0)
            {
                xp=x;
                yp=y-dy;
                S=F(xp,yp,t);
            }


            if (S==0)
            {
                xp=x-dx;
                yp=y;
                S=F(xp,yp,t);
            }


            if (S==0)
            {
                xp=x;
                yp=y+dy;
                S=F(xp,yp,t);
            }
            if (S==1)
            {
                x=xp;
                y=yp;
            }

            if (S==0)
            {
                t-=dt;
                dt/=2.0;
            }
        } // if
    } // do

    while (t<1);


}




//#include alg-lin/vecteur.h"


//========Variables globales ==========
/*
Vecteur X_powell;
double (*f_powell)(Vecteur &X);

//===========Fonction  minimiser ================
double func_powell(double *x)
{

    int n=X_powell.I;

    for (int i=1;i<=n;i++)// recopie x -> X
        X_powell[i-1+X_powell.i1]=x[i];
    //  cout<<"X="<<X_powell<<endl;
    return f_powell(X_powell);
}
*/
//========== Procedure de minimisation (utilise powell de nrecipes)==============
// entre: f: fonction  minimiser
//         X: point de dpart
// sortie: X: position du min: Xmin
//         return: valeur f(Xmin)
//exemple d'utilisation: -------------
/*
	 double F_test(Vecteur &X)
	 {
	 return sqr(X[1]-1)+sqr(X[2]-2);
	 }

	 Vecteur X(1,2);
	 double fmin= Cherche_min(F_test,X);
	 cout<<"Xmin="<<X<<"  fmin="<<fmin<<endl;
*/

/*
double Cherche_min(double (*f)(Vecteur &X),Vecteur &X)
{
    //-----initialise les variables globales ---------
    X_powell=X; //met la bonne taille
    f_powell=f;
    //-----------Initialisation des variables entre ---------------
    int n=X.I; // nombre de variables
    double *p=new double[n+1];  // point de depart
    for (int i=1;i<=n;i++)
        p[i]=X[i-1+X.i1];

    double **xi= new double*[n+1]; // direction de depart, initialise aux vecteurs unitaires
    for (int i=1;i<=n;i++)
    {
        xi[i]=new double[n+1];
        for (int j=1;j<=n;j++)
            xi[i][j]=0;

        xi[i][i]=1;
    }

    double ftol=1e-1;// tolerance  relative
    //--------Variables sortie ---------------------
    //  p: position du minimum
    //  xi: direction courante.
    int iter; //nbre d'iterations
    double fret; // valeur de la function  en p

    //----------Appelle fonction ----------------------------

    powell(p,xi,n,ftol,&iter,&fret,func_powell);

    for (int i=1;i<=n;i++)// recopie p -> X
        X[i-1+X.i1]=p[i];

    //------libere memoire ---------
    delete [] p;
    for (int i=1;i<=n;i++)
        delete [] xi[i];
    delete [] xi;

    return fret;
}
//=======================
// pour runge-Kutta
int FF_I; //nombre de variables
int FF_i1; // premier indice
Vecteur (*FF_F)(Vecteur &X, double t); // fonction  intgrer
void FF_derivs(double t,double *y,double *dydt)
{

    Vecteur X(FF_i1,FF_i1-1+FF_I);

    for (int i=1;i<=X.I; i++)
        X[i+FF_i1-1]=y[i];

    Vecteur DX=FF_F(X,t);


    for (int i=1;i<=X.I; i++)
        dydt[i]=DX[i+FF_i1-1];


}

//=======================================
// integre le champ de vecteur, par runge-kutta de numerical recipes
// entree: X(0), fonction F,t1,t2
// sortie: X(t)
void RungeKutta(Vecteur &X,double t1,double t2,Vecteur (*F)(Vecteur &,double ),double prec)
{
    int nok,nbad;
    double *y;
    y=new double[X.I+1];
    for (int i=1;i<=X.I; i++)
        y[i]=X[i+X.i1-1];

    FF_I=X.I;
    FF_i1=X.i1;
    FF_F=F;
    odeint(y,X.I,t1,t2,prec*1e-2,prec,0,&nok,&nbad,FF_derivs);

    for (int i=1;i<=X.I; i++)
        X[i+X.i1-1]=y[i];


}
//=======================
// pour runge-Kutta
int FFC_I; //nombre de variables complexes
int FFC_i1; // premier indice
VecteurC (*FFC_F)(VecteurC &X,double t); // fonction  intgrer
void FFC_derivs(double t,double *y,double *dydt)
{

    VecteurC X(FFC_i1,FFC_I+FFC_i1-1);

    for (int i=1;i<=X.I; i++)
        X[i+FFC_i1-1]=Complex(y[i],y[i+X.I]);

    VecteurC DX=FFC_F(X,t);


    for (int i=1;i<=X.I; i++)
    {
        dydt[i]=real(DX[i+FFC_i1-1]);
        dydt[i+X.I]=imag(DX[i+FFC_i1-1]);
    }

}


//=======================================
// integre le champ de vecteur, par runge-kutta de numerical recipes
// entree: X(0), fonction F, t1,t2
// sortie: X(t)
void RungeKutta(VecteurC &X,double t1,double t2,VecteurC (*F)(VecteurC &,double ),double prec)
{
    int nok,nbad;
    double *y;
    y=new double[2*X.I+1]; // (real,imag)
    for (int i=1;i<=X.I; i++)
    {
        y[i]=real(X[i+X.i1-1]);
        y[i+X.I]=imag(X[i+X.i1-1]);
    }

    FFC_I=X.I;
    FFC_i1=X.i1;
    FFC_F=F;
    odeint(y,2*X.I,t1,t2,prec*1e-2,prec,0,&nok,&nbad,FFC_derivs);

    for (int i=1;i<=X.I; i++)
        X[i+X.i1-1]=Complex(y[i],y[i+X.I]);

}
*/

/*
//========Recherche de racine de N equations ===========
int FF_Nparam; // nbre de variables

Vecteur (*FF_F2)(Vecteur &); // fonction  rsoudre
*/

#include <gsl/gsl_vector.h>
#include <gsl/gsl_multiroots.h>

/*
//---------------------------------
int print_state (size_t iter, gsl_multiroot_fsolver * s)
{
    printf ("iter = %3u x = % .3f % .3f "
            "f(x) = % .3e % .3e\n",
            iter,
            gsl_vector_get (s->x, 0),
            gsl_vector_get (s->x, 1),
            gsl_vector_get (s->f, 0),
            gsl_vector_get (s->f, 1));
    return 1;
}
*/
//---------------------------------
/*
int rosenbrock_f (const gsl_vector * x, void *params,           gsl_vector * f)
{
    //  cout<<"appel de f"<<endl;
    Vecteur V1(1,FF_Nparam);
    for (int i=1;i<=FF_Nparam;i++)
        V1[i]=gsl_vector_get (x, i-1);


    Vecteur V2=FF_F2(V1);

    for (int i=1;i<=FF_Nparam;i++)
        gsl_vector_set (f, i-1, V2[i]);

    return GSL_SUCCESS;
}
*/

/*
//---------------------------------
// Librairie GSL: Multirrot Solver par gsl_multiroot_fsolver_hybrids;
// entre: Fonction  annuler, Point de dpart, option verbose
// sortie: point final
void multiroot_fsolver( Vecteur (*F)(Vecteur &), Vecteur &V_init,int opt_v)
{
    FF_Nparam=V_init.I;
    FF_F2=F;

    if (opt_v)
        cout<<"Conditions initiales="<<V_init<<endl;
    //................
    const gsl_multiroot_fsolver_type *T;
    gsl_multiroot_fsolver *s;

    int status;
    size_t  iter = 0;

    const size_t n = FF_Nparam;
    //  struct rparams p = {1.0, 10.0};

    gsl_multiroot_function f = {&rosenbrock_f, n, 0};



    //double x_init[2] = {-10.0, -5.0};
    gsl_vector *x = gsl_vector_alloc (n);

    for (int i=1;i<=FF_Nparam;i++)
        gsl_vector_set (x, i-1,V_init[i]);


    T = gsl_multiroot_fsolver_hybrids;
    s = gsl_multiroot_fsolver_alloc (T, n);
    gsl_multiroot_fsolver_set (s, &f, x);

    if (opt_v)  print_state (iter, s);

    do
    {
        iter++;
        status = gsl_multiroot_fsolver_iterate (s);

        if (opt_v)
            print_state (iter, s);

        if (status)
            break;

        status =
            gsl_multiroot_test_residual (s->f, 1e-7);
    }
    while (status == GSL_CONTINUE && iter < 1000);

    if (opt_v)  printf ("status = %s\n", gsl_strerror (status));


    for (int i=1;i<=FF_Nparam;i++)
        V_init[i]=gsl_vector_get (s->x,i-1);


    gsl_multiroot_fsolver_free (s);
    gsl_vector_free (x);

    return;
}
*/

//=============================
// algo d'euclide: trouve (u,v)  partir de (a,b)
// tels que d=pgcd(a,b)=a*u+b*v
// entre: a,b
// sortie: d, u,v
long pgcd (long a, long b, long &u, long &v)
{
    long q, r, s, t, tmp;

    u = 1;
    v = 0;
    s = 0;
    t = 1;
    while (b > 0)
    {
        q = a / b;
        r = a % b;
        a = b;
        b = r;
        tmp = s;
        s = u - q * s;
        u = tmp;
        tmp = t;
        t = v - q * t;
        v = tmp;
    }
    return a;
}
//==============
int pgcd(int a,int b)
{
    long u,v;
    return (int)pgcd(a,b,u,v);

}
//==============
int pgcd(int a,int b,int c)
{
    return pgcd(pgcd(a,b),pgcd(b,c));
}
//=============
int ppcm(int a,int b)
{

    return a*b/pgcd(a,b);
}

//=====================
//pour une liste d'entiers
int pgcd(vector<int> & a)
{
	int res=a[0];
//	cout<<"res="<<res<<endl;
	for(int i=1;i<a.size();i++)
	{
		res=pgcd(res,a[i]);
//		cout<<"res="<<res<<endl;
	}
	return res;
}
//=========================
int ppcm(vector<int> & a)
{
	int res=a[0];
	for(int i=1;i<a.size();i++)
		res=ppcm(res,a[i]);
	return res;
}
	      
//=============
// decomposition en facteurs premiers d'un entier
// entree: entier N
// sortie: vecteur d'entiers vn=(n1,n2,..)  t.q. 
//             N=2^n1 3^n2 5^n3 ...
/*
Vecteur decomposition_facteurs_premiers(int N,Vecteur &primes)
{
  int P=primes.I;  

  if(P==0) // tableau non initialis
    {
      P=12; // nbre de nombre premiers utilis (2,3,5,7,11), donne P=5   (puis 13,17,19,23,29,31,37)
      primes.Init(0,P-1);
      primes[0]=2;    primes[1]=3;   primes[2]=5;   primes[3]=7;   primes[4]=11;    
      primes[5]=13;    primes[6]=17;   primes[7]=19;   primes[8]=23;   primes[9]=29;
      primes[10]=31;    primes[11]=37; 
    }


  //... pour le moment on fait " la main" ..
  Vecteur vn(0,P-1); // pour p=2,3,5,7,11 

  for(int p=0;p<=P-1; p++)
    {
      while((N%(int)primes[p])==0)
	{
	  vn[p]=vn[p]+1;
	  N=N/primes[p];
	}
    }// for p

  if(N!=1)
    cout<<"Erreur: il faut augmenter P dans aritm.cc"<<endl;
  return vn;
}
*/

//============
// Reduit la fraction
void Reduce(int& a,int &b)
{
	int p=pgcd(a,b);
	a/=p;
	b/=p;
}
	      
//=============
// decomposition en facteurs premiers d'une fraction
// entree: entiers N1/N2 et eventuellement tableau des premiers utiliss
// sortie: vecteur d'entiers vn=(n1,n2,..)  t.q. 
//             N1/N2=2^n1 3^n2 5^n3 ...r1/r2
// return 1 si on arrive  decomposer N cad r1=r2=1, 0 sinon
int  decomposition_facteurs_premiers(int N1,int N2,Col<int> &primes,Col<int> & vn,int &r1,int &r2)
{
	Col<int> vn1,vn2;
	int P=primes.size();  
	if(P==0) // tableau non initialis
	{
		primes={2,3,5,7,11,13,17,19,23,29,31,37};
		cout<<"J initialise le tableau primes"<<endl;
	}

	decomposition_facteurs_premiers(N1,primes,vn1,r1);
	decomposition_facteurs_premiers(N2,primes,vn2,r2);

	vn=vn1-vn2;
	Reduce(r1,r2);
	if((r1==1)&&(r2==1))
		return 1;
	else 
		return 0;


}
//=============
// decomposition en facteurs premiers d'un entier
// entree: entier N et eventuellement tableau des premiers utiliss
// sortie: vecteur d'entiers vn=(n1,n2,..)  t.q. 
//             N=2^n1 3^n2 5^n3 ... *r
// return 1 si r=1 cad si on arrive  decomposer N, 0 sinon
int  decomposition_facteurs_premiers(int N,Col<int> &primes,Col<int> & vn,int &r)
{
	if(N<=0)
		return 0;
	int P=primes.size();  
//	cout<<"P="<<P<<endl;

  if(P==0) // tableau non initialis
  {
	  primes={2,3,5,7,11,13,17,19,23,29,31,37};
	  cout<<"J initialise le tableau primes"<<endl;
  }
  //... pour le moment on fait " la main" ..
  vn.zeros(P);


  int N1=1;

//  cout<<"N="<<N<<endl;

  for(int p=0;p<P; p++)
    {
/*
		while(N%(N1*primes(p))==0)
		{
			vn(p)=vn(p)+1;
			N1*=primes(p);
		}
*/
		while((N%(int)primes(p))==0)
		{
			vn(p)=vn(p)+1;
			N=N/primes(p);
			//cout<<"N="<<N<<endl;
		}



    }// for p

  r=N;

  if(N!=1)
  {
	  //cout<<"Erreur: il faut augmenter P dans aritm.cc"<<endl;
	  return 0;
  }
  else
	  return 1;
}



//===========================
// fonction inverse de ci-dessus 
//entree: vn
// sortie: N1,N2 donnant le rationnel irreductible N2/N2
void prime_decomp_to_rationel(vector<int> &vn,int &N1,int &N2)
{
 Col<int> primes={2,3,5,7,11,13,17,19,23,29,31,37};

 N1=1; N2=1;

 for(int j=0;j<vn.size(); j++)
 {
	 if(j>primes.size())
	 {
		 cout<<"tableau primes pas assez grand dans prime_decomp_to_rationel(vector<int> &vn,int &N1,int &N2)"<<endl;
		 while(1);
	 }

	 int p=vn[j];
	 if(p>0)
		 N1*=pow(primes(j),p);
	 else if (p<0)
		 N2*=pow(primes(j),-p);
		 
 }
 

}

//===========================
// fonction inverse de ci-dessus 
//entree: vn
// sortie: N1,N2 donnant le rationnel irreductible N2/N2
/*
void prime_decomp_to_rationel(Vecteur &vn,int &N1,int &N2)
{


  int P=5; // nbre de nombre premiers utilis (2,3,5,7,11), donne P=5

  //.... initialisation du tableau des nbres premiers ...
  Vecteur   primes(0,P-1);
  primes[0]=2;    primes[1]=3;   primes[2]=5;   primes[3]=7;   primes[4]=11;    


  N1=1;N2=1;

  for(int p=0;p<=P-1; p++)
    {
      if(vn[p]>=1)
	N2=N2*pow(primes[p],vn[p]);
      else if(vn[p]<=-1)
	N1=N1*pow(primes[p],-vn[p]);
    }// for p

}

*/

//===================
/* entree: rationnel a/b avec a,b>0 et a<b.
sortie: a/b=[w0,w1,..,wn]= 1/(w0+ 1/ ...)
*/
void decomp_fraction_continue(int a,int b, vector<int> & w)
{
  if(w.size()>0)
    w.clear();

  if((a>=b)||(a<=0)||(b<=0))
    cerr<<"error: il faut 0<a,b et a<b dans aritm.cc"<<endl;
  
  while(a>0)
    {
      int w0=b/a;
      w.push_back(w0);
      int ap=b-w0*a;
      b=a;
      a=ap;
      //   cout<<","<<w0<<flush;
    }
}
//====================
/*
entre: x reel
sortie: approx a/b de x tq max(|a|,b)<=n
*/
double approx_rationelle(double x,int n,int &a,int &b,int opt_affich)
{
    int s=1;
    if (x<0)
    {
        s=-1;
        x=-x;
    }

//   cout<<"x="<<x<<endl;

    int b0=0,b1=1,a0=1,a1=floor(x);
    int a2=a1;
    int b2=1;
    // cout<<"   a/b="<<s*a2<<"/"<<b2<<"="<<s*a2*1./b2<<endl;


    double en=x - floor(x);
//   cout<<"     q="<<floor(x)<<" en="<<en<<endl;

    double err=fabs(x - a2*1./b2);

    int m=1;


    if ((err>1e-15)&&(maxi(a2,b2)<=n))
        do
        {
            a=a2;
            b=b2;
            int q=floor(1./en);
            en=1./en-q;
            //   cout<<"     q="<<q<<" en="<<en<<endl;
            a2=q*a1+a0;
            b2=q*b1+b0;
            double  asb=a2*1./b2;
            err=fabs(x - asb);


            a0=a1;
            b0=b1;
            a1=a2;
            b1=b2;

            if(opt_affich)
                    cout<<"   a/b="<<s*a2<<"/"<<b2<<"="<<s*a2*1./b2<<endl;

            m++;
        }
        while ((err>1e-15)&&(maxi(a2,b2)<=n));

    if ((err<=1e-15)&&(maxi(a2,b2)<=n))
    {
        a=a2;
        b=b2;
    }
    a=a*s;
    
    return a*1./b;
//
//    cout<<"x="<<s*x<<"   a/b="<<a<<"/"<<b<<"="<<a*1./b<<endl;
//    cout<<"---------"<<endl;
}



//====================
/*
entre: x reel
sortie: les a[i]/b[i] de x  pour i=1->n
*/
/*
void approx_rationelle_tableaux(double x,int n,Vecteur &Ta,Vecteur &Tb,int opt_affich)
{
    int s=1;
    if (x<0)
    {
        s=-1;
        x=-x;
    }

//   cout<<"x="<<x<<endl;
Ta.Init(1,n); Tb.Init(1,n);

int a,b;

    int b0=0,b1=1,a0=1,a1=floor(x);
    int a2=a1;
    int b2=1;
    // cout<<"   a/b="<<s*a2<<"/"<<b2<<"="<<s*a2*1./b2<<endl;


    double en=x - floor(x);
//   cout<<"     q="<<floor(x)<<" en="<<en<<endl;

    double err=fabs(x - a2*1./b2);

    


    for(int m=1; m<=n;m++)
       
        {
            a=a2;
            b=b2;
            int q=floor(1./en);
            en=1./en-q;
            //   cout<<"     q="<<q<<" en="<<en<<endl;
            a2=q*a1+a0;
            b2=q*b1+b0;
            double  asb=a2*1./b2;
            err=fabs(x - asb);


            a0=a1;
            b0=b1;
            a1=a2;
            b1=b2;

            Ta[m]=a*s; Tb[m]=b;
            if(opt_affich)
                    cout<<"   a/b="<<s*a2<<"/"<<b2<<"="<<s*a2*1./b2<<endl;

           
        }
       
    return ;
//
//    cout<<"x="<<s*x<<"   a/b="<<a<<"/"<<b<<"="<<a*1./b<<endl;
//    cout<<"---------"<<endl;
}
*/

//====================
/*
entre: x ,y  reel
        n entier
sortie: z reel tel que z=[x/y]*y  o [x/y] est une approx rationnelle a/b  de (x/y)    tq max(|a|,b)<=n
Cad que z est une approximation de x.

*/
double approx_rationelle(double x,double y, int n)
{
    double r=x/y;
    int a,b;
    approx_rationelle(r,n,a,b);
    double z=a*1./b*y;
    return z;
}

//=============================================
/*
  Decremente compt>=0, sachant que compt_pax est la "base"
sortie: compt et res=0 si (0,0,0..) est atteint, sinon res=1.


ex: compt=(1,1,3)  compt_max=(1,1,3)
 
donnera apres des appels successifs 
compt= (1,1,3), (0,1,3), (1,0,3), (0,0,3) ,(1,1,2)
(0,1,2),(1,0,2) , (0,0,2), etc .. (0,0,0) (et res=0)

*/
/*
int decremente(Vecteur &cpt, Vecteur &cpt_max) 
{
	cpt[cpt.i1]=cpt[cpt.i1]-1;
  
	for(int i=cpt.i1;i<=cpt.i2-1;i++)
    {
		if(cpt[i]<0)
		{
			cpt[i]=cpt_max[i];
			cpt[i+1]=cpt[i+1]-1;
		}
		else break;
    }
  
	if(cpt[cpt.i2]<0)
		return 0;
	else
		return 1;
}
*/
//............
int decremente(Col<int> &cpt, Col<int> &cpt_max) 
{
	cpt(0)=cpt(0)-1;
  
	for(int i=0;i<cpt.size()-1;i++)
    {
		if(cpt(i)<0)
		{
			cpt(i)=cpt_max(i);
			cpt(i+1)=cpt(i+1)-1;
		}
		else break;
    }
  
	if(cpt(cpt.size()-1)<0)
		return 0;
	else
		return 1;
}

//=========================
/*!
\param : n nombre d'elements,  
\param : p nombre d'indices, 1 <= p <= n
\param : I[j]  pour j=0 -> p-1 , 
       t.q. 1 <= I[0] < I[1] < ..<I[p-1] <= n

\return : I[j],j incrment en suivant l'ordre lexyco, avec j=0 en poids fort.
\return :  res= 0, si termin, 1 sinon.


\rem: au depart, il faut initialiser I[j]=j pour j=0 -> p-1.
    Au total, il y a C_np iterations avec res=0.

\example
   	int n=5,p=3;
	vector<int> i={1,2,3}; // depart
	while(incremente_Cnp(n,p,i)); // boucle

 resultat:
 I = {1,2,3}, {1,2,4}, {1,2,5}, {1,3,4}, {1,3,5},
           {1,4,5}, {2,3,4}, {2,3,5}, {2,4,5},
		   {3,4,5}.
 */

int incremente_Cnp(int n, int p, vector<int> &I) 
{

//... affichage
	if(0)
	{
		for(int i=0;i<I.size(); i++)
			cout<<I[i]<<", "<<flush;
		cout<<endl;
	}
//....

	if(I[p-1] < n)
	{
		I[p-1]=I[p-1]+1;
		return 1;
	}


	int k=p-2;
	int res=0;

	while(k >= 0)
	{
		if(I[k] < (I[k+1] - 1))
		{
			I[k] = I[k] + 1;
			for(int l=k+1; l<p; l++)
				I[l]=I[k]+l-k;
			res=1;
			break;
		}
		else
			k=k - 1;
		if (k== -1)
			res=0;
	}

	return res;
}



//============================
/*
renvoit la date de l'ordi en secondes
*/

#include <stdio.h>
#include <stdlib.h>
double Date_en_sec()
{
  double date;

  struct timespec ts;
  clock_gettime(CLOCK_MONOTONIC, &ts);  // donne l'heure -> structure ts

  date=ts.tv_sec+ 1e-9* ts.tv_nsec;
  return date;
}



//====== Matrice d'entiers ============

Matrice_i::Matrice_i()
{
  I=0;J=0;
}
void Matrice_i::Init(int Ii,int Ji)
{
  if((I>0)&&(J>0))
    Libere();

  I=Ii; J=Ji;
  t = new int* [I];
  for (int i=0; i <I; i++)
    t[i] = new int[J];

  for (int i=0; i <I; i++)
    for (int j=0; j <J; j++)
      t[i][j]=0; // initialisation

}

//====================
void Matrice_i::Libere()
{
  if((I>0)&&(J>0))
    {
      for (int i=0; i <I; i++)
	delete[] t[i];
      delete[] t;
    }
  I=0;J=0;
}

Matrice_i::~Matrice_i()
{
  Libere();
}
//==========================
ostream & operator <<(ostream & sortie,  const Matrice_i & M)
{
  for (int i=0;i<M.I;i++)
    {
      for  (int j=0;j<M.J;j++)
	sortie<<M.t[i][j]<<"\t|";
      
      cout<<"\n |";
    }

  sortie<<"\n";

  return sortie;
}




//==================

//=======================================
// Decompose la chaine "| .. | ..|" en sous chaines des caractres entre les '|' =delim
vector<string> Decompose(string ligne,char delim)
{
    vector<string> instructions;
    
    size_t pos=ligne.find(delim); // cherche le premier |
    ligne=ligne.substr(pos+1); // garde la suite seulement
    while(ligne.find(delim)!=string::npos) // il reste une instruction
    {
		size_t pos2= ligne.find(delim); 
		string ligne2=ligne.substr(0,pos2);
	
		//.... enleve les espaces au debut et fin de ligne2
		size_t pos3=ligne2.find_first_not_of(" ");
		ligne2=ligne2.substr(pos3);
		pos3=ligne2.find_last_not_of(" ");
		ligne2=ligne2.substr(0,pos3+1);
		//.................
		instructions.push_back(ligne2);
		ligne=ligne.substr(pos2+1);
	
		// if(opt_verbose>=4)
		//   cout<<" I="<<ligne2<<flush;
    }
    return instructions;
}
