#include <complex>
#include "config_fred.h"
//#include alg-lin/vecteur.h"
//#include alg-lin/matrice.h" 
//#include alg-lin/vecteurc.h"
#include "armadillo/armadillo.h"

#if !defined(__ARITM_H)
#define __ARITM_H


/* liste des .cc =1
   = geom/aritm.cc
   = geom/aritm2.cc
*/



#define SIGN(a,b) ((b)<0 ? -fabs(a) : fabs(a))
#define mini(A,B) ((A)<(B)?(A):(B))
#define maxi(A,B) ((A)<(B)?(B):(A))
 
//========== exp(complex) avec precision 1e-14============
Complex exp_p(Complex z);
//==== pour attendre: entre 1 ==========
void Suite();


//  #define abs(A) ((A)<(0)?(-(A)):(A))

// idem fmodl ?  
double modulo(double x,double y);   //x modulo y, dans l intervalle [0,y[


//===========================
// renvoit la valeur de x +k* z, la plus proche de y (k entier)
double Ajuste(double x,double y,double z);
// renvoit l'entier le plus proche
int Ajuste1(double x);


void Initialiser_le_hasard();
// Initialisation du generateur aleatoire, a appeler une seule fois par prog

//   division euclidienne : (x quelconque positif ou negatif, y>=0 )
int iquotient(int x,int y);
int ireste(int x,int y);

/*Liste des diviseurs de n
dans l'ordre croissant
 */
vector<int> liste_diviseurs(int n);



//=======================
//---- on decompose i en base N.
// entr: i,N,i1,i2
// sortie Vecteur mot
//              = i crit en base N,  et seulement mot[i1-i2] 
//Vecteur Decomposition_base(int i,int N,int i2);

//----- a^b ----
int ipow(int a,int b);


//===================
//  (-1)^n
int parite(int n);
//  (I)^n
Complex parite_I(int n);

//=============================
// algo d'euclide: trouve entiers (u,v)  partir des entiers (a,b)
// tels que d=pgcd(a,b)=a*u+b*v
// entree: a,b
// sortie: d, u,v
long pgcd (long a, long b, long &u, long &v);
int pgcd(int a,int b);
int pgcd(int a,int b,int c);
int ppcm(int a,int b);
int pgcd(vector<int> & a);
int ppcm(vector<int> & a);
//=============
// decomposition en facteurs premiers d'un entier
// entree: entier N
// sortie: vecteur d'entiers vn=(n1,n2,..)  t.q. 
//             N=2^n1 3^n2 5^n3 ...
// OBSOLETE
//Vecteur decomposition_facteurs_premiers(int N,Vecteur &primes);
   
//=============
// decomposition en facteurs premiers d'un entier
// entree: entier N et eventuellement primes: tableau des premiers utiliss
// sortie: vecteur d'entiers vn=(n1,n2,..)  t.q. 
//             N=2^n1 3^n2 5^n3 ...
// return 1 si on arrive  decomposer N, 0 sinon
int  decomposition_facteurs_premiers(int N,Col<int> &primes,Col<int> & vn,int &r);
int  decomposition_facteurs_premiers(int N1,int N2,Col<int> &primes,Col<int> & vn,int &r1,int &r2);

//===========================
// fonction inverse de ci-dessus 
//entree: vn
// sortie: N1,N2 donnant le rationnel irreductible N2/N2
//void prime_decomp_to_rationel(Vecteur &vn,int &N1,int &N2); 

void prime_decomp_to_rationel(vector<int> &vn,int &N1,int &N2);

//=============================================
/*
  Decremente compt>=0, sachant que compt_pax est la "base"
sortie: compt et res=0 si 0 est atteint, sinon res=1.
ex: compt=(2,3,1)  compt_max=(2,3,1)
 
donnera apres des appels successifs 
compt= (2,3,0), (2,2,1), (2,2,0), (2,1,1) ,(2,1,0)
(2,0,1),(2,0,0) , (1,3,1), etc .. (0,0,0) (et res=0)

*/
//int decremente(Vecteur &compt, Vecteur &compt_max);

int decremente(Col<int> &compt, Col<int> &compt_max);


int incremente_Cnp(int n, int p, vector<int> &I) ;

//================================
/* entree: rationnel a/b avec a,b>0 et a<b.
sortie: a/b=[w0,w1,..,wn]= 1/(w0+ 1/ ...)
*/
void decomp_fraction_continue(int a,int b, vector<int> & w);

//====================
/*
entre: double x, n>1
sortie: approx a/b de x au niveau n (cad a,b <n)
*/
double approx_rationelle(double x,int n,int &a,int &b,int opt_affich=0);

//====================
/*
entre: x ,y  reel
        n entier
sortie: z reel tel que z=[x/y]*y  o [x/y] est une approx rationnelle a/b  de (x/y)    tq max(|a|,b)<=n
Cad que z est une approximation de x.

*/
double approx_rationelle(double x,double y, int n);

//====================
/*
entre: x reel
sortie: les a[i]/b[i] de x  pour i=1->n
*/
//void approx_rationelle_tableaux(double x,int n,Vecteur &Ta,Vecteur &Tb,int opt_affich);

//========== carre============
double sqr(double x);

//========== signe ============
// renvoit 1,-1 selon le signe de x
int sign(double x);


//=== Kronecker ==================
//renvoit 1 si i=j  sinon renvoit 0
int Delta(int i,int j);


//====== partie entiere sans la frontiere: [x]m= 0 si x dans ]0,1] etc...
double floor_m(double x);

/*====================================================
Factorielle d'un entier  n!
et factorielle double n!!
*/
double fact(long n);
double fact(int n);
long double fact2(int n);
double dfact(long n);
double dfact(int  n);
/* ========================
rapport de deux factorielle:
   (n!)/(n-i)!
*/
double rfact(int n,int i);
long double rfact2(int n,int i);
/* ========================
rapport de deux factorielle:
   (n-i!)/(i)! avec 0<=i<=n
*/
double Rfact(int n,int i);


//======================================
/*
log(fact(x))=log(Gamma(x+1))
*/
double log_fact(double x);


//=================================
// Fonction de Bessel avec NR
double bessel_j(int n,double x);

/*====================================================
  coef du binome C(n,p) 
*/
double binome(long n,long p);

Complex binome(Complex z,long p);


//================ Fonction Zeta de Rimeann avec Giac et Pari.
Complex Zeta(Complex z);
/*===========================================
 Fonction Polynome d'Hermite   Hn(X)
 */
double Hermite(double X,int n);
/*===========================================
Tous les  Polynomes d'Hermite   Hn(X) pour n=0->N
 */
//Vecteur Hermite_tab(double X,int N);

/*=======================================================
Integrale 2d d'une fonction (vectorielle) z=f(x,y)
a N composantes: 1->N
et critere de precision sur la composante [indice]
entree:  discretisation nombre_x*nombre_y 
         si indice=0 -> pas de sous-discretisation.
*/
//Vecteur Integrale_2d(Vecteur (*fonct)(double,double), double x1,double x2,double y1,double y2,int N,int indice,int nombre_x,int nombre_y);

//================================================================

//=====================================================================
/* Calcul d'une integrale sur un carre avec acceleration de convergence
   (methode de Romberg), 
   x1 et x2 bornes de l'intervalle

   epsilon: tolerance sur le resultat, par exemple 10^-4
Pour les fonctions  vectorielles:
   indice: numero de bande par rapport auquel on optimise, par exemple 1 ou 2
           -1 : signifie precision sur toutes les bandes.
   N : nombre de niveaux

   */
//----------------------------------------

double Integrale_1d_romberg(double (*fonct)(double), double x1,double x2,double epsilon=1e-5,int n_romberg=7);

Complex Integrale_1d_romberg(Complex (*fonct)(double),double x1,double x2,double epsilon=1e-5,int n_romberg=7);

Complex Integrale_2d_romberg(Complex (*fonct)(double,double), double x1,double x2, double y1,double y2, double epsilon=1e-5);

// On impose une discretisation  l'echelle d'un quadrillage  Dx,Dy
// semble marcher
Complex Integrale_2d_romberg(Complex (*fonct)(double,double),double x1, double x2,double y1, double y2,double prec, double Dx,double Dy);
Complex Integrale_1d_romberg(Complex (*fonct)(double),double x1, double x2,double prec, double Dx);

//Vecteur romberg1d(Vecteur (*fonct)(double),		     double x1,double x2,int N,int indice=1,double epsilon=1e-5, int n_romberg=7);
//Vecteur romberg2d(Vecteur (*fonct)(double,double),		     double x1,double x2,double y1,double y2,int indice,int N,double epsilon=1e-5, int n_romberg=7);

//===========================================
/* Integrale par methode naive de Riemann */
/* prec= pas entre les points*/
Complex Integrale_1d_Riemann(Complex (*fonct)(double),double x1, double x2,double prec);
Complex Integrale_2d_Riemann(Complex (*fonct)(double,double),double x1, double x2,double y1, double y2,double prec);

//===========================================
/* Integrale par methode GSL */
// Problemees?
double Integrale_1d_GSL(double (*fonct)(double),double x1, double x2,double prec=1e-7);
Complex Integrale_1d_GSL(Complex (*fonct)(double),double x1, double x2,double prec=1e-7);

//===================================================================
/* Integrale par methode Numerical Recipes  sans singularit*/

double Integrale_1d_recipes(double (*f)(double),double x1, double x2);
Complex Integrale_1d_recipes(Complex (*fonct)(double),double x1, double x2);
Complex Integrale_2d_recipes(Complex (*fonct)(double,double),double x1, double x2,double y1, double y2);

//========== Procedure de minimisation (utilise powell de nrecipes)==============
// entre: f: fonction  minimiser
//         X: point de dpart
// sortie: X: position du min: Xmin
//         return: valeur f(Xmin)
//exemple d'utilisation: -------------
/*       
	 double F_test(Vecteur &X)
	 {
	 return sqr(X[1]-1)+sqr(X[2]-2); 
	 }

	 Vecteur X(1,2);
	 double fmin= Cherche_min(F_test,X);
	 cout<<"Xmin="<<X<<"  fmin="<<fmin<<endl;
*/

//double Cherche_min(double (*f)(Vecteur &X),Vecteur &X);

double Cherche_min(double (*f)(double), double x1, double x2, double prec,double & xmin);

/*=======================================================
  Recherche les zeros de la fonction f(x,y) >= 0
  par la methode du gradient
  
  entree : xy : point de depart
  fmin : seuil
  sortie : xy : minimum
  avec f(x,y)<=fmin
  */
void Recherche_min(double & x,double & y,double (*fonct)(double,double),double fmin=1e-5);

/* ==============================================================
  Suit un objet qui se deplace dans le plan x(t) y(t),
   pour t=0 a t=1.
  A l'aide de l'indicateur: 
      F(x,y,t)=1   si on est pres de l'objet
            =0   si on est loin.
 
  entree : x,y  pour t=0  t.q. F(x,y,0)=1
           F(x,y,t) : fonction
           dt : pas initial

  sortie : x,y  pour t=1   t.q. F(x,y,1)=1
*/
void Suivit(int (*F)(double,double,double), double & x,double & y, double dt,double dx, double dy);


//=======================================
// integre le champ de vecteur, par runge-kutta de numerical recipes
//  Rel ou Complexe
// entree: X(0), fonction F, t1,t2
// sortie: X(t)
//void RungeKutta(Vecteur &X,double t1,double t2,Vecteur (*F)(Vecteur &X,double t),double prec=1e-4);
//void RungeKutta(VecteurC &X,double t1,double t2,VecteurC (*F)(VecteurC &X,double t),double prec=1e-4);



//---------------------------------
// Librairie GSL: Multirrot Solver par gsl_multiroot_fsolver_hybrids;
// entre: Fonction  annuler, Point de dpart, option verbose
// sortie: point final
//void multiroot_fsolver( Vecteur (*F)(Vecteur &), Vecteur &V_init,int opt_v=0);

/* tir de borlandc math.h :Constants rounded for 21 decimals. */
/*#define M_E         2.71828182845904523536
  #define M_LOG2E     1.44269504088896340736
  #define M_LOG10E    0.434294481903251827651
  #define M_LN2       0.693147180559945309417
  #define M_LN10      2.30258509299404568402
  #define M_PI        3.14159265358979323846
  #define M_PI_2      1.57079632679489661923
  #define M_PI_4      0.785398163397448309616
  #define M_1_PI      0.318309886183790671538
  #define M_2_PI      0.636619772367581343076
  #define M_1_SQRTPI  0.564189583547756286948
  #define M_2_SQRTPI  1.12837916709551257390
  #define M_SQRT2     1.41421356237309504880
  #define M_SQRT_2    0.707106781186547524401
  */

 
//Complex I=Complex(0,1);

//============================================================




double Date_en_sec(); // renvoit la date de l'ordi en secondes




//=================================================
//====== Matrice d'entiers ============
class Matrice_i 
{
public:
  int **t;
  int I,J; // tailles

  Matrice_i();
  void Init(int I,int J);

  void Libere();
  ~Matrice_i();

friend ostream & operator <<(ostream & sortie, const Matrice_i & M);

};

//==============================================
/*--------  Recherche de chemins elementaires et maximaux dans un graphe
entree: Adj: matrice adjacence du graphe N*N, indices i,j=0->N-1

sortie:
   liste de chemins.
   un  chemin = suite de sommets

Algo:
On utilise la matrice d'adjacence du graphe.
On procede par recursivit:

On a dj parcouru un bout de chemin et on est  un sommet S.
On parcourt dans l'ordre les aretes partant de S, menant  un autre sommet S',
 -  si S' est pas dans la liste des sommets dj parcourus: on y va (appel recursif)
-  sinon on passe au suivant.
- si tous les sommets S' sont parcourus sans qu'aucun ne soit possible, alors le chemin est maximal: on le memorise dans une liste.


Exemple: 
    
 */
vector<vector<int> >  Liste_des_chemins_elementaires();//(Matrice_i Adj);




// Decompose la chaine "| .. | ..|" en sous chaines des caractres entre les '|' =delim
vector<string> Decompose(string ligne,char delim='|');



#endif



