#include "root/gdefs.h"
#include "geom/aritm.h"


#include <iostream>
#include <iomanip>
#include <sstream>

#include <TLatex.h>
#include <TSystem.h>
#include <TLatex.h>
#include <TArc.h>
#include <TF1.h>
#include <TArrow.h>


 double x_v(0),y_v(0); // coordonnees en memoire
 int color_v(1); // couleur
 int width_v(1); // largeur de ligne
 int style_v(1); // style de ligne

//------------------------
void move2(double x,double y)
{
x_v=x;
y_v=y;
}
//------------------------
void draw2(double x,double y)
{
 TLine *l= new TLine(x_v,y_v,x,y);
 x_v=x; y_v=y;
 l->SetLineColor(color_v);
 l->SetLineWidth(width_v);
 l->SetLineStyle(style_v);
 l->Draw();

 // objets_v.Add(l); // rajoute aux objets
 //objets_v[objets_v.GetLast()]->Draw(); // dessine
}
//------------------------
void draw_arrow2(double x,double y)
{
 TArrow *l= new TArrow(x_v,y_v,x,y);
 x_v=x; y_v=y;
 l->SetLineColor(color_v);
 l->SetLineWidth(width_v);
 l->SetLineStyle(style_v);
 l->SetArrowSize(0.02);
 l->Draw("|>");

 // objets_v.Add(l); // rajoute aux objets
 //objets_v[objets_v.GetLast()]->Draw(); // dessine
}
//-----------------
void draw2(double x,double y,int col,int width,int style)
{
  color_v=col;  width_v=width; style_v=style;  
    draw2(x,y);
}

//---------------------------------
void drawline(double x1,double y1,double x2,double y2,int col,int width,int style)
{

 TLine *l= new TLine(x1,y1,x2,y2);
 x_v=x2; y_v=y2;
 l->SetLineColor(col);
 l->SetLineWidth(width);
 l->SetLineStyle(style);
 l->Draw();
}

void drawtext(double x,double y, const char * s, double size)
{
  TLatex *text=new TLatex(); 
  text->SetTextSize(size);
  text->DrawLatex(x,y,s);
}

//-----------------------
void color(int c)
{
  color_v=c;
}

//=================================
TArc * circle(double x,double y, double r,int col, double phi1, double phi2, int FillStyle)
{
  TArc *e=new TArc(x,y,r,phi1,phi2);

  e->SetLineColor(col);
  e->SetFillStyle(FillStyle);
  e->SetFillColor(col);
  e->Draw("only"); // pour ne pas tracer les rayons.
}
//=========================================
// dessin arc de cercle (angles en radian)par segments de droites. sens=+1: direct
void Dessin_arc(double xc,double yc,double R,double a1,double a2,int sens)
{
if(sens==-1)
  {
   double at=a2; a2=a1; a1=at;
  }


  while(a2<a1)
    a2+=2*Pi_;

  while(a2>a1+2*Pi_)
     a2-=2*Pi_;


 double x0,y0,x1,y1;
 TLine *l;
 x0=xc+R*cos(a1);
 y0=yc+R*sin(a1);

double  a=a1;

while (a<a2)
  {
 a=a+0.05;
 if(a>a2) a=a2;
 x1=xc+R*cos(a);
 y1=yc+R*sin(a);

 l= new TLine(x0,y0,x1,y1);
 l->SetLineColor(BLACK);
 l->Draw();
 x0=x1; y0=y1;
}




}
//========================================================
// Dessin point (petit cercle: style=6)
TMarker * point(double x,double y,  int col,int style,int size)
{
   TMarker *pp=new TMarker(x,y,style); // style=6:petit cercle
   pp->SetMarkerColor(col);
   pp->SetMarkerSize(size);
   pp->Draw();
   x_v=x; y_v=y;
   return pp;
}

//======Assigne x_v,y_v ===============
void Set_xv_yv(double xv,double yv)
{x_v=xv; y_v=yv;
}
//================================================
/* Sauve fichier titre.gif dans repertoire rep (defaut ="."), de la fenetre c en mode batch
 */
void Sauve_gif(TPad *c,const char * titre,const char *rep,int xsize,int ysize)
{
  /*
 ostringstream chaine1,chaine2,chaine3,chaine4,chaine5,chaine6,chaine7;

 chaine1<<rep<<"/"<<titre<<".eps"<<ends;   // chaine1="rep/titre.eps"
 //chaine2<<"pstopnm  -portrait -xsize  "<<xsize<<"  -ysize "<<ysize<<" "<<chaine1.str()<<";"<<ends;
 chaine2<<"pstopnm  -portrait "<<chaine1.str().c_str()<<";"<<ends;
 chaine3<<rep<<"/"<<titre<<".eps001.ppm"<<ends;   // chaine3="rep/titre.eps001.ppm"
 chaine4<<rep<<"/"<<titre<<".gif"<<ends;   // chaine4="rep/titre.gif"
 chaine5<<" ppmtogif "<<chaine3.str()<<" > "<<chaine4.str().c_str()<<";"<<ends;
 chaine6<<"rm -f "<<chaine3.str().c_str()<<";"<<ends;
 chaine7<<" rm -f "<<chaine1.str().c_str()<<";"<<ends;


 c->SaveAs(chaine1.str().c_str());
 gSystem->Exec(chaine2.str().c_str());
 gSystem->Exec(chaine5.str().c_str());
      gSystem->Exec(chaine6.str().c_str());
      gSystem->Exec(chaine7.str().c_str());
  */
  ostringstream chaine4;
 chaine4<<rep<<"/"<<titre<<".gif"<<ends;   // chaine4="rep/titre.gif"

 c->SaveAs(chaine4.str().c_str());

}

//============================================
/* Cre fichier d'animation nom_fichier.gif dans repertoire rep="." (par default).
   (si i<imax, une image gif est cre. Si i=imax, elles sont unifie pour former un seul fichier d'animation.

  i: indice courant
  imin,imax: intervalle de i
  nom_fichier: "nom"  nom du fichier final animation
  texte: texte  afficher  sur la fenetre
  rep: repertoire final du fichier
  periode (en 1/100 sec)

ex. utilisation:

Animation(i,0,i+1,"film_Tv"); //-> cree image i
Animation(i,0,i,"film_Tv"); // -> cree image et film
Animation(i,0,i-1,"film_Tv"); // -> cree  film (pas de derniere image)

*/

void Animation(int i,int imin,int imax,const char * nom_fichier,int periode,const char * texte, const char * rep)
{
	Animation(gPad,i,imin,imax,nom_fichier, periode, texte, rep);
}
//---------
void Animation(TVirtualPad*c, int i,int imin,int imax,const char * nom_fichier,int periode,const char * texte, const char * rep)
{
	int opt_jpg=0; //creation du film mp4  partir des images .jpg 

		
	if(i<=imax)
	{
	

		//.... affiche le texte ....
//  fen->cd();
		//  TText text(0.3,0.95,texte); text.SetNDC(kTRUE);
		TLatex text(0.1,0.95,texte); text.SetNDC(kTRUE);
		text.Draw();
		//fen->Update();


//..... sauve image png..................

  
  
		ostringstream chaine_gif;
		// cela impose 5 chiffres et rajoute des 0 devant si il faut
		chaine_gif<<rep<<"/"<<nom_fichier<<"_"<<setfill ('0') <<setw (5)<<i<<".png"<<ends; 
// fen->SaveAs(chaine_gif.str().c_str());
		c->SaveAs(chaine_gif.str().c_str());
 
		//.... sauve image jpeg aussi ...
  
		ostringstream chaine_jpg;
		if(opt_jpg)
		{
			chaine_jpg<<rep<<"/"<<nom_fichier<<"_"<<setfill ('0') <<setw (5)<<i<<".jpg"<<ends; 
//       fen->SaveAs(chaine_jpg.str().c_str());
			c->SaveAs(chaine_jpg.str().c_str());
		}
		//...........................
	}
 
 if(i>=imax)
   {
    //----------- creation du film gif anim  partir des images .gif ------------
     /*  
     cout<<"On fait le film.gif.."<<endl;
    ostringstream com;//commande
    com<<"gifsicle  --colors 256 -d="<<periode<<" "; // cadence temporelle
    for(int it=1;it<=(imax-imin+1); it++)
	com<<rep<<"/"<<nom_fichier<<"_"<<setfill ('0') <<setw (5)<<it<<".gif ";
    com<<"  > "<<rep<<"/"<<nom_fichier<<".gif;  gifsicle -b -O2 "<<rep<<"/"<<nom_fichier<<".gif"<<ends;
    gSystem->Exec(com.str().c_str());
*/
     //----------- creation du film gif anim  partir des images png (en convertissant en gif et utilise gifsicle)  ------------
     cout<<"On fait le film.gif.."<<endl;
    ostringstream com;//commande
    com<<"convert "<<nom_fichier<<"_*.png  GIF:- | gifsicle --delay="<<periode<<" --loop --optimize=2 --colors=256 --multifile - > "<<nom_fichier<<".gif"<<ends;

    gSystem->Exec(com.str().c_str());

    
    ostringstream com2;//commande pour effacers fichiers intermediares
    com2<<"rm -f "<<rep<<"/"<<nom_fichier<<"_*.png "<<ends;
    gSystem->Exec(com2.str().c_str());
    
 cout<<"Les fichiers animation: "<<rep<<"/"<<nom_fichier<<".gif  ont ete cree. Voir avec xanim."<<endl;

    //----------- creation du film mp4  partir des images .jpg ------------
    if(opt_jpg)
      {
	int fps=100./periode ;// nbre images /sec.
	ostringstream com3;
	com3<<"    mencoder -mf fps="<<fps<<" \"mf://*.jpg\" -o "<<rep<<"/"<<nom_fichier<<".avi  -ovc lavc -lavcopts vcodec=mjpeg"<<ends;
	//com3<<"mencoder "<<rep<<"/"<<nom_fichier<<".gif  -ovc lavc -o "<<rep<<"/"<<nom_fichier<<".avi"<<ends;
	gSystem->Exec(com3.str().c_str());


	ostringstream com4;//commande pour effacers fichiers intermediares
	com4<<"rm -f "<<rep<<"/"<<nom_fichier<<"_*.jpg "<<ends;
	gSystem->Exec(com4.str().c_str());
 cout<<"Les fichiers animation: "<<rep<<"/"<<nom_fichier<<".avi  ont t cr. Voir avec mplayer."<<endl;
      }
    
//-------------------------------------------------
   
	   }

}

// ----------
void Recree_Animation(int imin,int imax,const char * nom_fichier,int periode)
{

	cout<<"On fait le film.."<<endl;


	ostringstream com;//commande
    com<<"convert "<<nom_fichier<<"_*.png  GIF:- | gifsicle --delay="<<periode<<" --loop --optimize=2 --colors=256 --multifile - > "<<nom_fichier<<".gif"<<ends;

    gSystem->Exec(com.str().c_str());

    
    cout<<"Les fichiers animation: "<<nom_fichier<<".gif a t cr. Voir avec animate ."<<endl;
   

}


//================================================================
// Pour dessiner une fonction F(x)
double (*P_fonct)(double);

//----------------- y=f(x) ---------------------
double fonction_fx(double * xx,double *par)
{
   double x=xx[0];
   return P_fonct(x);
}
//-------------------------------------------------

void Dessin_Fonction_x(double (*fonct)(double),double xmin,double xmax,const char *titre, const char * opt_dessin)
{
    P_fonct=fonct;

  TCanvas *c=new TCanvas(titre,titre,5);


  TF1 *f1 = new TF1("f1",fonction_fx,xmin,xmax,0); // "type C
  f1->Draw(opt_dessin);
  c->Update();

}



//-------constructeur --------
TH1D_f::TH1D_f(const char* name,const char* title, int nbinsx,double xmin,double xmax):TH1D(name,title, nbinsx,xmin,xmax)
{
    cout<<"Constructeur de TH1D_f"<<endl;
    this->SetStats(0);
    //    numero_s=n_s_i;
}
TH1D_f::TH1D_f(TH1D h)
{
    *this=h;
}
//==========================================
//------evenement souris---------------------
void TH1D_f::ExecuteEvent(Int_t event, Int_t px, Int_t py)
{
    
        _Event(event,px,py);
    
}
 
 
 
//-------constructeur --------
TH2F_f::TH2F_f(const char* name,const char* title, int nbinsx,double xmin,double xmax,int nbinsy,double ymin,double ymax):TH2F(name,title, nbinsx,xmin,xmax,nbinsy,ymin,ymax)
{
    cout<<"Constructeur de TH2F_f"<<endl;
    this->SetStats(0);
  
 
}
 
 
 
void Event_triade(TH2F_f * h,Int_t event, Int_t px, Int_t py);
void Event_Note(TH2F_f * h,Int_t event, Int_t px, Int_t py);
 
//==========================================
//------evenement souris---------------------
void TH2F_f::ExecuteEvent(Int_t event, Int_t px, Int_t py)
{
 
  _Event(event,px,py);
  
  
}
 
 
 
 
