/*
diverses pour faire du graphisme avec root
*/


//#include <TROOT.h>

#include <TApplication.h>

#include <TCanvas.h>
#include <TObjArray.h>



#include <TLine.h>
#include <TEllipse.h>
#include <TArc.h>
#include <TPolyMarker.h>
#include <TMarker.h>
#include <TText.h>
#include <TGraph.h>
#include <TH2.h>
#include <TH1.h>

#if !defined(__GDEF_H)
#define __GDEF_H

//=================================
//variables globales

#define RED 2
#define BLUE 4
#define BLACK 1
#define GREEN 3
#define YELLOW 5
#define PINK 6
#define SKY 7
#define GREEN_GRAY 8
#define BLUE_GRAY 9
#define WHITE 0
/*
static double x_v(0),y_v(0); // coordonnees en memoire
static int color_v(1); // couleur
static int width_v(1); // largeur de ligne
*/
//------------------------


void move2(double x,double y);
void draw2(double x,double y);
void draw2(double x,double y,int col,int width=1,int style=1);
void draw_arrow2(double x,double y);
void drawline(double x1,double y1,double x2,double y2,int col,int width=1,int style=1);

void drawtext(double x,double y, const char * s, double size=0.02);

void color(int c);

//... FillStyle: 1001: Solid
TArc * circle(double x,double y, double r, int col=BLACK,double phi1=0, double phi2=360,int FillStyle=0);
TMarker * point(double x,double y,int col=BLACK,int style=6,int size=1);


void Set_xv_yv(double xv,double yv);
//=========================================
// dessin arc de cercle (angles en radian)par segments de droites. sens=+1: direct
void Dessin_arc(double xc,double yc,double R,double a1,double a2,int sens=+1);


//================================================
/* Sauve fichier titre.gif dans repertoire rep (defaut ="."), de la fenetre c en mode batch
 */
void Sauve_gif(TPad *c,const char * titre,const char *rep,int xsize=400,int ysize=269);



//============================================
/* Cre fichier d'animation nom_fichier.gif dans repertoire rep="." (par default).
   (si i<imax, une image gif est cre. Si i=imax, elles sont unifie pour former un seul fichier d'animation.
  fen: fenetre du dessin
  i: indice courant
  imin,imax: intervalle de i
  nom_fichier: "nom"  nom du fichier final animation
  texte: texte  afficher  sur la fenetre
  rep: repertoire final du fichier
  periode (50 ms)
*/
void Animation(int i,int imin,int imax,const char * nom_fichier="film",int periode=50,const char * texte=" ", const char * rep=".");
void Animation(TVirtualPad *c, int i,int imin,int imax, const char * nom_fichier="film",int periode=50,const char * texte=" ", const char * rep=".");

void Recree_Animation(int imin,int imax,const char * nom_fichier="film",int periode=50);

//==========================================================================================
// Pour dessiner une fonction F(x)
void Dessin_Fonction_x(double (*fonct)(double),double xmin,double xmax,const char *titre="Fx", const char * opt_dessin="hist");





///=========================================
//Classe pour capturer la souris dans un TH1
 
class TH1D_f  : public TH1D
{
public:
 
    
  void (*_Event)(Int_t event, Int_t px, Int_t py) ;  // pointeur sur fonction evenement souris
  
  
    //-------constructeur --------
    TH1D_f(const char* name,const char* title, int nbinsx,double xmin,double xmax);
    TH1D_f(TH1D h);
 
 
    //------evenement souris---------------------
    void ExecuteEvent(Int_t event, Int_t px, Int_t py);
 
};
 
 
 
 
 
//=========================================
//Classe pour capturer la souris dans un TH2
// idem TH1D_f ci-dessus 

/*
Utilisation:
  Dans une classe
   il faut un object: 
   TH2F_f *h; // histo pour les choix, qui capte les Events

   Dans une fonction Dessin ou dans le constructeur:

   h=new TH2F_f("titre","titre",0,0,2*NM,0,0,NM+2); // histogramme avec fonction Event.  juste pour creer un cadre
 
    h->GetXaxis()->SetTitle("N2");
    h->GetYaxis()->SetTitle("N1");
 
    h->Draw("");
 

    h->_Event=_Event_Tonnetz; // fonction Event  appeler si evenement souris

 Puis dans le fichier .cc   dclarer:
      Tonnetz *p_tonnetz; // pointeur sur l'objet courant


puis ecrire une fonction:

void _Event_Tonnetz(Int_t event, Int_t px, Int_t py)
{ 
    p_tonnetz->Event_Tonnetz(event,px,py);
}

et une fonction membre de la classe:

void Tonnetz::Event_Tonnetz(Int_t event, Int_t px, Int_t py)
{
...
}

//---------- gestion des Event:

//..... coordonnes de la souris :

double xd,yd;
xd = gPad->AbsPixeltoX(px);
yd = gPad->AbsPixeltoY(py);
 

double x = gPad->PadtoX(xd);
double y = gPad->PadtoY(yd);
 
cout<<"Dans Event_Tonnetz event="<<event<<" xd="<<xd<<" yd="<<yd<<" x="<<x<<" y="<<y<<endl;
 
//.... touches clavier:

  if (event==kKeyPress) // touche appuye
    {
 
        cout<<"touche px="<<px<<endl;
 
        switch (px)
        {
        case 'a': //  on met/enleve la basse
	}

 if (event==1) // 1: CLIC GAUCHE
    {
     ...
    }


Infos sur les events:

enum EEventType {
   kNoEvent       =  0,
   kButton1Down   =  1, kButton2Down   =  2, kButton3Down   =  3, kKeyDown  =  4,
   kButton1Up     = 11, kButton2Up     = 12, kButton3Up     = 13, kKeyUp    = 14,
   kButton1Motion = 21, kButton2Motion = 22, kButton3Motion = 23, kKeyPress = 24,
   kButton1Locate = 41, kButton2Locate = 42, kButton3Locate = 43, kESC      = 27,
   kMouseMotion   = 51, kMouseEnter    = 52, kMouseLeave    = 53,
   kButton1Double = 61, kButton2Double = 62, kButton3Double = 63
};


*/


class TH2F_f  : public TH2F
{
public:
 
  
 
  void (*_Event)(Int_t event, Int_t px, Int_t py) ;  // pointeur sur fonction evenement souris
  
 
 
    //-------constructeur --------
    TH2F_f(const char* name,const char* title, int nbinsx,double xmin,double xmax,int nbinsy,double ymin,double ymax);
 
 
    //------evenement souris---------------------
    void ExecuteEvent(Int_t event, Int_t px, Int_t py);
 
};
 
 
 
 
 
 
#endif
